unit Uencrypt;

interface

const Vertauschwerte: Array[0..255] of byte = (
170, 121, 9, 253, 63, 65, 45, 115,
16, 126, 112, 60, 81, 222, 133, 71,
242, 21, 169, 238, 237, 88, 84, 27,
56, 229, 208, 106, 99, 152, 129, 207, 
110, 200, 8, 48, 139, 163, 108, 185, 
212, 100, 189, 228, 217, 122, 53, 215, 
206, 147, 46, 51, 193, 194, 116, 165, 
248, 166, 142, 98, 94, 171, 14, 31, 
12, 49, 211, 0, 146, 255, 225, 249, 
117, 5, 151, 34, 70, 68, 172, 123, 
201, 42, 221, 57, 95, 203, 219, 96, 
235, 150, 224, 149, 143, 82, 155, 251, 
120, 241, 173, 29, 124, 77, 148, 7, 
89, 72, 178, 33, 127, 136, 213, 209, 
35, 138, 22, 40, 4, 250, 119, 17, 
24, 174, 6, 79, 50, 153, 125, 210, 
246, 62, 135, 67, 158, 240, 252, 144, 
52, 145, 2, 85, 187, 25, 245, 107, 
204, 167, 254, 190, 39, 205, 87, 30, 
118, 157, 131, 37, 176, 83, 109, 220, 
232, 132, 11, 214, 55, 38, 114, 154, 
130, 247, 54, 23, 199, 181, 177, 191, 
28, 183, 230, 15, 231, 92, 74, 111, 
26, 179, 164, 244, 10, 236, 198, 20, 
128, 175, 196, 64, 103, 186, 19, 93, 
134, 168, 76, 75, 47, 69, 188, 202, 
239, 86, 97, 182, 243, 227, 78, 102, 
36, 223, 113, 3, 13, 195, 161, 66, 
44, 73, 137, 43, 140, 180, 41, 91, 
1, 233, 141, 105, 18, 234, 216, 80,
160, 90, 218, 197, 61, 162, 58, 159,
59, 184, 32, 101, 226, 192, 156, 104);

const hexString: String = '0123456789abcdef';
const ZweierPotenzen: Array[0..7] of byte = (1,2,4,8,16,32,64,128);


function encrypt(s: String):String;
function decrypt(s: String):String;
function ntesBit(c: char; n: integer):Boolean;


implementation

function dectohex(w: word):string;
var h,l: byte;
    s: string;
begin
   h := w div 16;
   l := w - 16*h;
   s := HexString[h + 1] + HexString[l + 1];
   dectohex := s;
end;

function hextodec(s:string):word;
var c: char;
    w: word;
begin
   c := s[1];
   if (ord('a') <= ord(c)) and (ord('f') >= ord(c)) then w := ( (ord(c) - ord('a'))+10)*16
     else w := (ord(c) - ord('0'))*16;
   c := s[2];
   if (ord('a') <= ord(c)) and (ord('f') >= ord(c)) then w := w + ((ord(c) - ord('a'))+10)
     else w := w + (ord(c) - ord('0'));
   hextodec := w;
end;

function ntesBit(c: char; n: integer):Boolean;
var b: boolean;
begin
   b := (ord(c) and Zweierpotenzen[n]) <> 0;
   ntesBit := b;
end;

function encrypt(s: String):String;
var anz: word;
    s1: string;
    charposr, bitposr, bitposw: integer;
    cr: char;
    bw: byte;
    lo: byte;
    i,j: integer;
    raus: boolean;
begin

// Schritt 1: Bitweise vermischen: zuerst kommen alle ersten Bits aller Zeichen,
// dann alle 2. Bits, ...
    anz := length(s);
    bitposw := 0; bw := 0;
    s1 := '';
    for bitposr := 0 to 7 do
    begin
       for charposr := 1 to anz do
       begin
           cr := s[charposr];
           if ntesbit(cr,bitposr) then bw := bw or Zweierpotenzen[bitposw];
           inc(bitposw);
           if bitposw = 8 then
           begin
              s1 := s1 + chr(bw);
              bitposw := 0; bw := 0;
           end;
       end;
    end;
// Schritt 2: addieren ohne bertrag von links nach rechts
   for i := 1 to anz - 1 do
   s1[i] := chr(  (ord(s1[i]) + ord(s1[i+1])) and 255 );


    s := '';
    for i := 1 to anz do
    begin
       lo := ord(s1[i]);
        j := 0; raus := false;
        while (j <= 255) and not raus do
           if Vertauschwerte[j] = lo then
           begin
              lo := j; raus := true;
           end else inc(j);
        s := s + dectohex(lo);
    end;


    encrypt := s;
end;

function decrypt(s: String):String;
Var s1: string;
    i,w: integer;
    Anz: integer;
    bitr, bitw,cw: integer;
    bit: boolean;
begin
   Anz := length(s) div 2;

// Schritt 1: von Hexadezimal auf Byte umrechnen
   s1 := '';
   for i := 1 to Anz do
      s1  := s1 + chr(Vertauschwerte[hextodec(copy(s,2*i-1,2))]);

// Schritt 2: subtrahieren ohne bertrag von rechts nach links
   for i := 1 to anz - 1 do
   begin
   w := ord(s1[anz - i]) - ord(s1[anz - i + 1]);
   if w < 0 then w := 256 + w;
   s1[anz - i] :=  chr(w);
   end;


// Schritt 3: Bits wieder auseinandersortieren
   s := '';
   for i := 1 to anz do s := s + chr(0);
   bitw := 0; cw := 1;
   for i := 1 to anz do
   begin
      for bitr := 0 to 7 do
      begin
         bit := (ord(s1[i]) and zweierpotenzen[bitr]) <> 0;
         if bit then
            s[cw] := chr( ord(s[cw]) or zweierpotenzen[bitw]);
         cw := cw + 1;
         if cw = anz + 1 then
         begin
            cw := 1; inc(bitw);
         end;
      end;
   end;

   decrypt := s;
end;

end.
